#!/bin/bash

cd /root/ || exit 1

NUM_CORES=4
LOG_DIR="/root/floofy_logs"
mkdir -p "$LOG_DIR"

echo "📦 Starting $NUM_CORES floofy miners with unique addresses and logging to $LOG_DIR"

for i in $(seq 1 $NUM_CORES); do
  SCREEN_NAME="floofy_miner_$i"
  LOG_FILE="$LOG_DIR/miner_$i.log"

  # Generate a unique address for this miner
  MINING_ADDRESS=$(./floofy-cli getnewaddress "miner_$i")

  echo "⛏️ Miner $i → address: $MINING_ADDRESS"

  # Kill existing screen session if running
  screen -S "$SCREEN_NAME" -X quit 2>/dev/null || true

  # Start new screen session
  screen -dmS "$SCREEN_NAME" bash -c "
    echo '⛏️ Miner $i started. Mining to $MINING_ADDRESS...' >> \"$LOG_FILE\"
    while true; do
      OUTPUT=\$(./floofy-cli generatetoaddress 1 \"$MINING_ADDRESS\" 2>&1)
      echo \"[\$(date '+%Y-%m-%d %H:%M:%S')] \$OUTPUT\" >> \"$LOG_FILE\"
      sleep 0.5
    done
  "
done
